if not context.getReference():
  return context.Base_redirect('view',keep_items={'portal_status_message': 'Reference is not defined'})

reference = context.getReference()

data_supply = context.portal_catalog.getResultValue(
  validation_state='validated',
  reference = reference,
  portal_type='Data Supply')

if data_supply:
  if batch:
    return data_supply
  return data_supply.Base_redirect('view',keep_items={'portal_status_message': 'Data Supply already created'})

data_supply = context.data_supply_module.newContent(
  portal_type = 'Data Supply',
  source = 'organisation_module/ors_end_device',
  source_section = 'organisation_module/ors_end_device',
  destination = 'organisation_module/ors_data_center',
  reference = reference
)

data_supply.newContent(
  portal_type='Data Supply Line',
  title='Data Stream',
  reference='out_stream',
  quantity=1,
  int_index=2,
  use='big_data/ingestion/stream',
  resource="data_product_module/ors_end_device"
).validate()

data_supply.newContent(
  portal_type='Data Supply Line',
  title='Ingest Data',
  reference='ingestion_operation',
  quantity=1,
  int_index=1,
  aggregate_value=context,
  resource='data_operation_module/wendelin_ingest_data'
).validate()

data_supply.validate()
if batch:
  return data_supply
return data_supply.Base_redirect('view',keep_items={'portal_status_message': 'Data Supply is created'})
